Index: main/plugin-syndication/sitemap.xmap
===================================================================
--- main/plugin-syndication/sitemap.xmap	(revision 28681)
+++ main/plugin-syndication/sitemap.xmap	(working copy)
@@ -1,6 +1,6 @@
 <?xml version="1.0" encoding="ISO-8859-1"?>
 <!--
-   Copyright 2010 Anyware Services
+   Copyright 2015 Anyware Services
 
    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
@@ -16,24 +16,56 @@
    -->
 <map:sitemap xmlns:map="http://apache.org/cocoon/sitemap/1.0">
     <map:components>
+        <map:selectors>
+            <map:selector name="request-parameter" src="org.apache.cocoon.selection.RequestParameterSelector" logger="sitemap.selector.requestparameter" />
+        </map:selectors>
+    
         <map:generators>
             <map:generator name="feed" src="org.ametys.plugins.syndication.FeedGenerator"/>
+            <map:generator name="feeds" src="org.ametys.plugins.syndication.FeedsGenerator"/>
         </map:generators>
+        
+        <map:actions>
+            <map:action name="create-conf" src="org.ametys.plugins.syndication.CreateUserConfAction" />
+        </map:actions>
     </map:components>
 	<map:pipelines>
 		<map:pipeline>
-			<map:match pattern="feed/read.xhtml">
-				<map:generate type="feed" src="{parent-context-attr:url}">
-					<map:parameter name="length" value="{parent-context-attr:length}"/>
-				</map:generate>
-				<map:transform type="i18n">
-					<map:parameter name="locale" value="{locale:locale}"/>
-				</map:transform>
-				<map:transform src="service://@xslt"/>
-				<map:transform type="i18n">
-					<map:parameter name="locale" value="{request-attr:sitemapLanguage}"/>
-					 <map:parameter name="plugin" value="{request-attr:pluginName}"/>
-				</map:transform>
+		   <map:match pattern="feed/read.xhtml">
+                <map:generate type="feeds" />
+                <map:transform type="i18n">
+                    <map:parameter name="locale" value="{locale:locale}"/>
+                </map:transform>
+                <map:transform src="service://@xslt"/>
+                <map:transform type="i18n">
+                    <map:parameter name="locale" value="{request-attr:sitemapLanguage}"/>
+                    <map:parameter name="plugin" value="{request-attr:pluginName}"/>
+                </map:transform>
+                <map:serialize type="xml"/>
+            </map:match>
+		    
+		    <map:match pattern="create-conf">
+                <map:act type="create-conf">
+                    <map:generate type="action-result" label="xml"/>
+                    <map:transform type="i18n">
+                        <map:parameter name="locale" value="{locale:locale}"/>
+                        <map:parameter name="default-catalogue-id" value="plugin.{request-attr:pluginName}"/>
+                    </map:transform>
+                    <map:select type="request-parameter">
+                        <map:parameter name="parameter-name" value="ajax"/>
+                        <map:when test="true">
+                            <map:serialize type="xml"/>
+                        </map:when>
+                        <map:otherwise>
+                            <map:transform src="service://pages/services/feed/xsl/result.xsl"/>
+                            <map:serialize type="xml"/>
+                        </map:otherwise>
+                    </map:select>
+                </map:act>
+            </map:match>
+		
+			<map:match pattern="feed">
+				<map:generate type="feed" />
 				<map:serialize type="xml"/>
 			</map:match>
 			
Index: main/plugin-syndication/pages/services/feed/feed2xhtml.xsl
===================================================================
--- main/plugin-syndication/pages/services/feed/feed2xhtml.xsl	(revision 28681)
+++ main/plugin-syndication/pages/services/feed/feed2xhtml.xsl	(working copy)
@@ -1,6 +1,6 @@
 <?xml version="1.0" encoding="ISO-8859-1"?>
 <!--
-   Copyright 2010 Anyware Services
+   Copyright 2015 Anyware Services
 
    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
@@ -21,38 +21,43 @@
 
     <xsl:param name="header" select="ametys:serviceParameter('header')"/>
 
-	<xsl:template match="/feed">
+	<xsl:template match="/rssFeeds">
 		<html>
 			<head>
 				<!-- CSS -->
 				<link href="{ametys:pluginResourceURL('syndication', 'css/service-feed.css')}" rel="stylesheet" type="text/css" />
-			</head>
+			    <xsl:if test="ametys:renderingContext() = 'back'">
+    			    <link href="{ametys:pluginResourceURL('syndication', 'css/bo-error.css')}" rel="stylesheet" type="text/css" />
+			    </xsl:if>
+            </head>
 			
 			<body>
 				<xsl:if test="$header != ''"><h3><xsl:value-of select="$header"/></h3></xsl:if>
 			
 				<div class="feed-wrapper">
-					
-					<xsl:apply-templates select="image"/>
-					
-					<h1><xsl:value-of select="@title"/></h1>
-					<h2><xsl:value-of select="@description"/></h2>
-					
-					<!-- 
-					<xsl:if test="link">
-						<a class="rss-link" href="{link}" title="{title}"><xsl:value-of select="link"></xsl:value-of></a>
-					</xsl:if>
-					 -->
-					 
-					 <!-- 
-					<xsl:if test="lastBuildDate">
-						<div class="rss-date"><xsl:value-of select="lastBuildDate"/></div>
-					</xsl:if>
-					-->
-					 
-					<div class="feed-entry-list">
-						<xsl:apply-templates select="entry"/>
-					</div>
+					<xsl:for-each select="feed">
+						
+						<xsl:apply-templates select="image"/>
+						
+						<h1><xsl:value-of select="@title"/></h1>
+						<h2><xsl:value-of select="@description"/></h2>
+						
+						<!-- 
+						<xsl:if test="link">
+							<a class="rss-link" href="{link}" title="{title}"><xsl:value-of select="link"></xsl:value-of></a>
+						</xsl:if>
+						 -->
+						 
+						 <!-- 
+						<xsl:if test="lastBuildDate">
+							<div class="rss-date"><xsl:value-of select="lastBuildDate"/></div>
+						</xsl:if>
+						-->
+						 
+						<div class="feed-entry-list">
+							<xsl:apply-templates select="entry"/>
+						</div>
+					</xsl:for-each>
 					
 				</div>
 			</body>
Index: main/plugin-syndication/pages/services/feed/utils/preference.xsl
===================================================================
--- main/plugin-syndication/pages/services/feed/utils/preference.xsl	(revision 0)
+++ main/plugin-syndication/pages/services/feed/utils/preference.xsl	(revision 0)
@@ -0,0 +1,285 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!--
+   Copyright 2015 Anyware Services
+
+   Licensed under the Apache License, Version 2.0 (the "License");
+   you may not use this file except in compliance with the License.
+   You may obtain a copy of the License at
+
+       http://www.apache.org/licenses/LICENSE-2.0
+
+   Unless required by applicable law or agreed to in writing, software
+   distributed under the License is distributed on an "AS IS" BASIS,
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+   See the License for the specific language governing permissions and
+   limitations under the License.
+   -->
+<xsl:stylesheet version="1.0" 
+                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+                xmlns:ametys="org.ametys.web.transformation.xslt.AmetysXSLTHelper"
+                xmlns:math="http://exslt.org/math" 
+                xmlns:resolver="org.ametys.cms.transformation.xslt.ResolveURIComponent"
+                xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
+                extension-element-prefixes="math ametys resolver">
+         
+    <xsl:template name="feed-get-url">
+        <xsl:value-of select="concat(ametys:siteUriPrefix(), '/', ametys:lang(), '/_plugins/syndication/page/create-conf')"/>
+    </xsl:template>            
+
+    <xsl:template name="configure-links-btn-text">
+        <i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_POPUP_CONFIG" i18n:catalogue="plugin.syndication"/>
+    </xsl:template>
+
+    <xsl:template name="configure-links-btn">
+	    <p id="feed-config-header-{$uniqueId}"><xsl:call-template name="configure-links-btn-text"/></p>
+	    <script type="text/javascript">
+	        $j("#feed-config-header-<xsl:value-of select="$uniqueId"/>").wrapInner("&lt;a class='config' href='javascript: feed_config_form_popup_<xsl:value-of select="$uniqueId"/>()'&gt;&lt;/a&gt;")
+	    </script>
+    </xsl:template>
+                
+    <xsl:template name="feed-config-form">
+        <xsl:if test="/rssFeeds/@showForm = 'true'">
+	        <xsl:variable name="feed-url"><xsl:call-template name="feed-get-url"/></xsl:variable>
+	        
+	        <div class="feed-config-form">
+	            <xsl:call-template name="configure-links-btn" />
+	            
+	            <form id="feed-config-{$uniqueId}" action="{$feed-url}" method="post">
+	                <div id="feed-config-form-{$uniqueId}" class="feed-config-form">
+	
+			            <p>
+			            <i18n:translate>
+			              <i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_POPUP_CONFIG_INFO" i18n:catalogue="plugin.syndication"/>
+			              <i18n:param><xsl:if test="/rssFeeds/@nbMax != 0"><xsl:value-of select="/rssFeeds/@nbMax"/></xsl:if></i18n:param>
+			            </i18n:translate>
+			            </p>
+			            <noscript>
+			               <p>
+			                   <i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_POPUP_CONFIG_INFO_FEED_MAX" i18n:catalogue="plugin.syndication"/><xsl:value-of select="/rssFeeds/@nbMax" />
+			               </p>
+			            </noscript>
+	                    <input type="hidden" name="zone-item-id" id="zone-item-id-{$uniqueId}" value="{/rssFeeds/@zoneItemId}"/>
+	                    <input type="hidden" name="nbMaxCheck" id="nb-max-check-{$uniqueId}" value="{/rssFeeds/@nbMax}"/>
+	                    <input type="hidden" name="nbFeedService" id="nb-feed-service-{$uniqueId}" value="{/rssFeeds/@nbFeedService}"/>
+	                    <input type="hidden" name="nbMaxUser" id="nb-max-user-{$uniqueId}" value="{/rssFeeds/@nbMaxUser}"/>
+	                    <xsl:for-each select="/rssFeeds/feed-conf">
+	                            <xsl:if test="@isCustom = 'false'">
+	                                <xsl:call-template name="feed-config-form-feeds">
+	                                    <xsl:with-param name="position" select="position()"/>
+	                                </xsl:call-template>
+	                            </xsl:if>
+	                    </xsl:for-each>
+	                    <br/>
+	                    <xsl:if test="count(/rssFeeds/feed-conf[@isCustom = 'true']) != 0">
+		                    <p><i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_POPUP_CONFIG_INFO2" i18n:catalogue="plugin.syndication"/></p>
+		                    <xsl:for-each select="/rssFeeds/feed-conf">
+		                            <xsl:if test="@isCustom = 'true'">
+		                                <xsl:call-template name="feed-config-form-feeds-custom">
+		                                    <xsl:with-param name="position" select="position()"/>
+		                                </xsl:call-template>
+		                            </xsl:if>
+		                    </xsl:for-each>
+	                    </xsl:if>
+	                    <xsl:call-template name="feed-config-form-field-submit"/> 
+	                    <div class="feed-config-form-bottom"></div>
+	                </div>
+	            </form>
+	            
+	            <xsl:call-template name="feed-form-script"/>
+	        </div>
+	   </xsl:if>
+    </xsl:template>
+    
+    <xsl:template name="feed-config-form-feeds">
+        <xsl:param name="position" />
+        <xsl:variable name="name">
+	        <xsl:choose>
+	            <xsl:when test="@feedName != ''">
+	                <xsl:value-of select="@feedName"/>
+	            </xsl:when>
+	            <xsl:otherwise>
+	                <xsl:value-of select="@feedUrl"/>
+	            </xsl:otherwise>
+	        </xsl:choose>
+        </xsl:variable>
+        <div class="field checkbox">
+            <div class="input">
+                <input type="checkbox" name="feed-check-{$position}" id="feed-config-{$uniqueId}-check-{$position}">
+                    <xsl:if test="@isCheck = 'true'"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if>
+                </input>
+            </div>
+            <div class="label">
+                <label for="feed-config-{$uniqueId}-check-{$position}"><xsl:value-of select="$name"/></label>
+            </div>
+            <div class="field-end"></div>
+        </div>
+    </xsl:template>
+    
+    <xsl:template name="feed-config-form-feeds-custom">
+        <xsl:param name="position" />
+        <div class="field checkbox">
+            <div class="input">
+                <input type="checkbox" name="feed-check-{$position}" id="feed-config-{$uniqueId}-check-{$position}">
+                    <xsl:if test="@isCheck = 'true'"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if>
+                </input>
+            </div>
+            <div class="label">
+                <input type="input" onkeyup="check_{$uniqueId}('feed-config-{$uniqueId}-check-{$position}')" name="feed-url-{$position}" id="feed-config-{$uniqueId}-url-{$position}" value="{@feedUrl}"/>
+            </div>
+            <div class="field-end"></div>
+        </div>
+    </xsl:template>
+    
+    <xsl:template name="feed-config-form-field-submit">
+         <!-- Template for submit button -->
+         <div id="feed-config-submit-{$uniqueId}">
+             <xsl:call-template name="common-utils-input-submit">
+                 <xsl:with-param name="i18nkey" select="'plugin.syndication:SYNDICATION_SERVICE_CONFIG_RSS_FORM_POPUP_RECORD'" />                
+                 <xsl:with-param name="onclick">return feed_config_form_submit_<xsl:value-of select="$uniqueId"/>();</xsl:with-param>                
+             </xsl:call-template>
+         </div>
+    </xsl:template>
+    
+    <xsl:template name="feed-form-script">
+        <script type="text/javascript">
+            function check_<xsl:value-of select="$uniqueId"/>(id)
+            {
+                var checkBox = $j("#" + id);
+                if (!checkBox[0].checked)
+                {
+                    checkBox[0].click()
+                }
+            }
+        
+            function feed_config_form_switch_<xsl:value-of select="$uniqueId"/>()
+            {
+                var form = document.getElementById('feed-config-<xsl:value-of select="$uniqueId"/>');
+                var submit = document.getElementById('feed-config-submit-<xsl:value-of select="$uniqueId"/>');
+                form.style.display = (form.style.display == 'none') ? '' : 'none';
+                submit.style.display = (submit.style.display == 'none') ? '' : 'none';
+            }
+            feed_config_form_switch_<xsl:value-of select="$uniqueId"/>();
+            
+            function feed_config_form_popup_<xsl:value-of select="$uniqueId"/>()
+            {
+                $j("#feed-config-form-<xsl:value-of select="$uniqueId"/> script").remove();
+                $j("#feed-config-form-<xsl:value-of select="$uniqueId"/>").dialog({
+                  resizable: false,
+                  height:'410',
+                  width: '380',
+                  modal: true,
+                  title: '<i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_POPUP_TITLE" i18n:catalogue="plugin.syndication"/>',
+                  buttons: {
+                    <i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_POPUP_RECORD" i18n:catalogue="plugin.syndication"/>: function() {
+                      feed_config_form_submit_<xsl:value-of select="$uniqueId"/>();
+                    },
+                    <i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_POPUP_CANCEL" i18n:catalogue="plugin.syndication"/>: function() {
+                      $j( this ).dialog( "close" );
+                    }
+                  }
+                });
+            }
+            
+            function feed_config_form_submit_<xsl:value-of select="$uniqueId"/>()
+            {
+                var nbMaxCheck = <xsl:value-of select="/rssFeeds/@nbMax"/>;
+                var nbMaxUser = <xsl:value-of select="/rssFeeds/@nbMaxUser"/>;
+                var nbFeedService = <xsl:value-of select="/rssFeeds/@nbFeedService"/>;
+                if (!checkNbFeed_<xsl:value-of select="$uniqueId"/>(nbMaxCheck) &amp;&amp; nbMaxCheck != 0)
+                {
+                    alert("<i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_ERROR_TO_MANY_CHECK" i18n:catalogue="plugin.syndication"/>");
+                    return false;
+                }
+                else
+                {
+                    var i = 1;
+                    var checkBox = $j("#feed-config-<xsl:value-of select="$uniqueId"/>-check-" + i);
+                    var zoneItemInput = $j("#zone-item-id-<xsl:value-of select="$uniqueId"/>");
+                    
+                    var data = {
+                        "ajax": "true",
+                        "zone-item-id": zoneItemInput.val(),
+                        "nbMaxCheck": nbMaxCheck,
+                        "nbFeedService": nbFeedService,
+                        "nbMaxUser": nbMaxUser
+                    };
+                    
+                    while (checkBox[0] != null)
+                    {
+                        data["feed-check-" + i] = checkBox[0].checked;
+                        var inputUrl = $j("#feed-config-<xsl:value-of select="$uniqueId"/>-url-" + i);
+                        if (inputUrl[0] != null)
+                        {
+                            data["feed-url-" + i] = inputUrl[0].value;
+                        }
+                        i++;
+                        checkBox = $j("#feed-config-<xsl:value-of select="$uniqueId"/>-check-" + i);
+                    }
+                  
+                    // send it in ajax
+                    function result(data)
+                    {
+                        var s = "";
+                        $j('errors error', data).each(function () { s += $j(this).text() + "\n"; });
+                        
+                        if (s == "")
+                        {
+                            var errors = $j('error', data);
+                            if (errors.size() == 0)
+                            {
+                                $j("#feed-config-form-<xsl:value-of select="$uniqueId"/>").dialog( "close" );
+                                alert("<i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_OK" i18n:catalogue="plugin.syndication"/>");
+                                location.reload();
+                            }
+                            else
+                            {
+                                var errorInfo = "";
+                                errors.each(function() {
+                                    errorInfo += $j(this).text();
+                                }); 
+                                alert(errorInfo)
+                            }
+                        }
+                        else
+                        {
+                            alert(s);
+                        }
+                    }
+                    
+                    function handleError(jqXHR, textStatus, errorThrown)
+                    {
+                        alert("<i18n:text i18n:key="PLUGINS_CMS_CONTENT_COMMENTS_FORM_ERROR_AJAX" i18n:catalogue="plugin.cms"/>");
+                    }
+                    
+                    $j.ajax({
+                        url: "<xsl:value-of select="$uri-prefix"/>/plugins/syndication/create-conf",
+                        data: data,
+                        type: 'post',
+                        success: result,
+                        error: handleError
+                    });
+                }
+            }
+            
+            function checkNbFeed_<xsl:value-of select="$uniqueId"/>(nbMaxCheck)
+            {
+               var i = 1;
+               var checkBox = $j("#feed-config-<xsl:value-of select="$uniqueId"/>-check-" + i);
+               
+               var nbCheck = 0;
+               while (checkBox[0] != null)
+               {
+                    if (checkBox[0].checked)
+                    {
+                        nbCheck++;
+                    }
+                    i++;
+                    checkBox = $j("#feed-config-<xsl:value-of select="$uniqueId"/>-check-" + i);
+               }
+               
+               return !(nbCheck > nbMaxCheck);
+            }
+        </script>
+    </xsl:template> 
+                
+</xsl:stylesheet>
\ No newline at end of file
Index: main/plugin-syndication/pages/services/feed/utils/result.xsl
===================================================================
--- main/plugin-syndication/pages/services/feed/utils/result.xsl	(revision 0)
+++ main/plugin-syndication/pages/services/feed/utils/result.xsl	(revision 0)
@@ -0,0 +1,55 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!--
+   Copyright 2015 Anyware Services
+
+   Licensed under the Apache License, Version 2.0 (the "License");
+   you may not use this file except in compliance with the License.
+   You may obtain a copy of the License at
+
+       http://www.apache.org/licenses/LICENSE-2.0
+
+   Unless required by applicable law or agreed to in writing, software
+   distributed under the License is distributed on an "AS IS" BASIS,
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+   See the License for the specific language governing permissions and
+   limitations under the License.
+   -->
+<xsl:stylesheet version="1.0" 
+	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+	xmlns:i18n="http://apache.org/cocoon/i18n/2.1">
+	
+	<xsl:template match="/ActionResult">
+		<html>
+			<head/>
+			
+			<body id="default">
+				<xsl:choose>
+					<xsl:when test="error">
+						<div class="form-errors">
+							<h1><i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_ERROR" i18n:catalogue="plugin.syndication"/></h1>
+							<p><xsl:value-of select="error"/></p>
+							<noscript>
+								<p><i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_BACK_ALT" i18n:catalogue="plugin.syndication"/></p>
+							</noscript>
+							<script type="text/javascript">
+								document.write("&lt;p&gt;&lt;a href='javascript: history.back();'&gt;<i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_BACK" i18n:catalogue="plugin.syndication"/>&lt;/a&gt;&lt;/p&gt;")
+							</script>
+						</div>
+					</xsl:when>
+					<xsl:otherwise>
+						<div class="form-message">
+							<h1><i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_SUCCESS" i18n:catalogue="plugin.syndication"/></h1>
+							<noscript>
+								<p><i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_BACK_ALT_SUCCESS" i18n:catalogue="plugin.syndication"/></p>
+							</noscript>
+							<script type="text/javascript">
+								document.write("&lt;p&gt;&lt;a href='javascript: history.back();'&gt;<i18n:text i18n:key="SYNDICATION_SERVICE_CONFIG_RSS_FORM_BACK" i18n:catalogue="plugin.syndication"/>&lt;/a&gt;&lt;/p&gt;")
+							</script>
+						</div>							
+					</xsl:otherwise>
+				</xsl:choose>
+			</body>
+		</html>
+	</xsl:template>
+	
+</xsl:stylesheet>
\ No newline at end of file
